pipeline {
    agent any
    tools {
        nodejs 'node'
    }
    stages {
        stage('Build') {
            steps {
                sh 'ls -la'
                sh 'node -v && npm -v'
                sh 'ls -la'
                sh 'npm install'
            }
        }
    }
}

node {
  def commitHash = checkout(scm).GIT_COMMIT
  dir("./") {
    docker.withTool("docker") {
      // Section with docker registry address
      docker.withRegistry('https://registry.jcpenney.griddynamics.net') {
          env.PATH = "${tool 'docker'}/bin:${env.PATH}"
          // Image name
          def newApp = docker.build("cloud-ops-jenkins:${env.BRANCH_NAME}-${new Date().format('yyyyMMdd')}-${env.BUILD_NUMBER}")
          // Version name is same with branch name
          def version = "${env.BRANCH_NAME}-${new Date().format('yyyyMMdd')}-${env.BUILD_NUMBER}"
          newApp.push(version)
          sh "docker rmi --force cloud-ops-jenkins:${env.BRANCH_NAME}-${new Date().format('yyyyMMdd')}-${env.BUILD_NUMBER}"
      }
    }

  }
}
